# -*- coding: utf-8 -*-
from syslog import *

import subprocess
#-------------------------------------------------------------------------------
#
#-------------------------------------------------------------------------------
class BaseHandler:

	#=======================================================
	# 
	#=======================================================
	def __init__(self):
		self.config = ""
		self.name =""
	#=======================================================
	# 
	#=======================================================
	def log(self, msg, level=LOG_INFO):
		try:
			str = ""
			if self.name:
				str = "(%s) " % self.name
			str += msg
			syslog(level, str)
			print( str )
		except:
			pass
	#=======================================================
	# 
	#=======================================================
	def Get(self, request):
		print("Get")
		return None, 406
	#=======================================================
	# 
	#=======================================================
	def Put(self, request):
		print("Put", request.json)
		return 406

	#=======================================================
	# 
	#=======================================================
	def Post(self, request):
		print("Post", request.json)
		return 406
	
	#=======================================================
	# 
	#=======================================================
	def service(self, name, action):

		result = subprocess.call(['service', name, action])

		return result
	#=======================================================
	# 
	#=======================================================
	def service_status(self, name):
		result = subprocess.check_output(['service', name, 'status'],universal_newlines=True)
		return result

	#=======================================================
	# 
	#=======================================================
	def call(self, args, shell=False):

		result = subprocess.call(args, shell=shell)
		return result

	#=======================================================
	# 
	#=======================================================
	def check_output(self, args, shell=False):

		result = subprocess.check_output(args, shell=shell,  universal_newlines=True)
		return result

	#=======================================================
	# 
	#=======================================================
	def firewallCmd(self, args, permanent=False):

		print (args)
		try:
			result = self.check_output("firewall-cmd --%s " % args, shell=True)
			if permanent:
				result = self.check_output("firewall-cmd --permanent --%s" % args, shell=True)
		except Exception as e:
			result = False
			self.log(e)

		return result

	#=======================================================
	# 
	#=======================================================
	def used_port(self):

		used_port = {'tcp':[],'tcp6':[],'udp':[],'udp6':[]}

		netstat = self.check_output(["netstat", "-antu"])
		port_lines = netstat.split('\n')
		for line in port_lines:
			line = line.split(' ')
			sline = []
			for i in line:
				if i:
					sline.append(i)

			if sline and sline[0] in ['tcp','tcp6','udp','udp6']:
				port = sline[3].split(':')[-1]
				if not port in used_port[sline[0]]:
					used_port[sline[0]].append(port)
		return used_port
		
	#=======================================================
	# 
	#=======================================================
	def port_process(self, protocol, port):

		try:
			use_proc =self.check_output('lsof -i%s:%s' % (protocol, port), shell=True)
			sline = use_proc.split('\n')
			result = sline[1].split(' ')[0]

		except:
			result = False

		return result

	#=======================================================
	# 
	#=======================================================
	def check_ipaddr(self, addr):

		result = True
		if addr:
			sp_addr = addr.split('.')
			if 1 > int(sp_addr[0]) or 233 < int(sp_addr[0]):
				result = False
			elif 1 > int(sp_addr[3]) or 254 < int(sp_addr[3]):
				result = False

		return result

	#=======================================================
	# 
	#=======================================================
	def getAddr(self, interface):
		
		ipaddr = ''
		try:
			lines = self.check_output(['ip','addr','show',interface]).split('\n')
			for line in lines:
				if line.find('inet') > 0:
					ipaddr = line.strip(' ').split(' ')[1].split('/')[0]
		except:
			pass
		return ipaddr
