# -*- coding: utf-8 -*-
from Handlers import BaseHandler
import os
#-------------------------------------------------------------------------------
#
#-------------------------------------------------------------------------------
class DHCP(BaseHandler.BaseHandler):
	#=======================================================
	# 
	#=======================================================
	def __init__(self):
		self.config = "/etc/dnsmasq.d/mae_webui"
		self.name = 'DHCP'

	#=======================================================
	# 
	#=======================================================
	def Get(self, request):
		status = 200
		return self.readConfig(), status
	#=======================================================
	# 
	#=======================================================
	def Put(self, request):

		status = 200
		self.writeConfig(request.json)
		self.service('dnsmasq', 'restart')
		return status
	#=======================================================
	# 
	#=======================================================
	def readConfig(self):

		config = {'enable':'no','rangeTop':'', 'rangeEnd':''} 
		if os.path.exists(self.config):
			fd = open(self.config, "r")
			for line in fd:
				if line.startswith('dhcp-range'):
					sline = line.strip('\n').split('=')
					params = sline[1].split(',')
					if len(params) == 3:
						config['enable']   = 'yes'
						config['rangeTop'] = params[0]
						config['rangeEnd'] = params[1]
			fd.close()
		return config

	#=======================================================
	# 
	#=======================================================
	def writeConfig(self, args):

		fd = open(self.config, "w")
		if args['enable'] == 'yes':
			dhcp_range = 'dhcp-range=%s,%s,12h' % (args['rangeTop'], args['rangeEnd'])
			fd.write(dhcp_range)
			
		fd.close()
