# -*- coding: utf-8 -*-
from Handlers import BaseHandler

#-------------------------------------------------------------------------------
#
#-------------------------------------------------------------------------------
class Setting(BaseHandler.BaseHandler):
	#=======================================================
	# 
	#=======================================================
	def __init__(self):
		self.passwd = "/etc/nginx/.htpasswd"
		self.nginx_conf = "/etc/nginx/sites-available/default"
		self.name = 'Setting'
		self.account = 'admin'

	#=======================================================
	# 
	#=======================================================
	def Get(self, request):

		status = 200
		type = request.query.type
		if type ==  'webuiport':
			port =  self.httpPort(None, True)
			result = {'type':'webuiport', 'webuiport': port}
		
		return result, status
	#=======================================================
	# 
	#=======================================================
	def Put(self, request):

		status = 200
		args = request.json
		if args['type'] == 'password':
			self.setPassword(args)
		elif args['type'] == 'webuiport':
			if self.httpportValidator(args):
				self.httpPort(args)
			else:
				status = 409

		return status
	#=======================================================
	# 
	#=======================================================
	def setPassword(self, args):
		
		if args['password']:
			passwd = self.check_output(['openssl', 'passwd', '-apr1', args['password']])
			fd = open(self.passwd, 'w')
			fd.write(':'.join((self.account,passwd)))
			fd.close()
			self.service('nginx', 'reload')

	#=======================================================
	# 
	#=======================================================
	def httpPort(self, args, read=False):
		
		fd = open(self.nginx_conf,'r')
		config = fd.read()
		fd.close()
		start = config.find('listen')
		end = config.find('default_server;')
		port = config[start:end].strip('listen').strip(' ')
		
		if read:
			return port
		else:
			fd = open(self.nginx_conf,'w')
			new_conf = config.replace( config[start:end], 'listen %s ' % args['webuiport'])
			fd.write(new_conf)
			fd.close()
			self.service('nginx', 'reload')
	#=======================================================
	# 
	#=======================================================
	def httpportValidator(self,args):
		
		result = True
		process =  self.port_process('tcp', args['webuiport'])
		if process and not 'nginx' in process:
			used_port = self.used_port()
			if args['webuiport'] in used_port['tcp'] or args['webuiport'] in used_port['tcp6']:
				result = False
		return result
		